DevExtreme v23.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Overview

This example demonstrates how to show and hide the Popup component, populate it with content, specify its position and other settings.

To see step-by-step instructions on how to get started with the DevExtreme Popup component, refer to the following tutorial: Getting Started with Popup.

Show and Hide the Popup

Call the show() method to display the Popup. To close a Popup, choose one of the following options:

  • Built-in close button
    Enable the showCloseButton property to display the Close button in a Popup's top toolbar.

  • Custom close button
    This demo shows how to add custom buttons to the Popup. One of them uses an onClick handler to call the hide() method that closes the Popup. Refer to the next section (Configure the Popup) to learn how you can populate a popup with custom controls.

  • On outside click
    Enable the hideOnOutsideClick property to allow users to hide the Popup by clicking outside the component.

Configure the Popup

The Popup inner area is divided into three parts:

  • Top toolbar

    • Predefined
      Set showTitle to true and use the title property to specify the caption. The Close button will appear if you do not disable the showCloseButton property.

    • Custom
      Add toolbarItems markup and set each item's toolbar property to top. If you want to display an item in the overflow menu, as shown in this demo, set the item's locateInMenu property to always. You can also assign never to this property to keep the item outside the overflow menu, or you can assign auto to hide the item in the menu if the Popup's width decreases.

  • Content area
    To populate the Popup with content, use the contentTemplate property.

  • Bottom toolbar
    To enable the bottom toolbar, declare the toolbarItems array as shown in this demo. Set each item's toolbar property to bottom. To learn more about toolbar configuration, refer to the following tutorial: Getting Started with Toolbar

Resize and Position

To specify Popup size, use the height and width properties.

In this demo, each Popup's location is relative to the image. The code specifies the my, at, and of properties of the position object. The configuration in the demo reads as follows: "place my center side at the bottom side of the #image${employee.ID} element."

Use the container property to select the container in which you want to render the Popup. If you set the container property to an element on the page, the shading applies to this element.

Turn on the dragEnabled option to allow users to move the Popup around the page.

Backend API
$(() => { let employee = null; const popupContentTemplate = function () { return $('<div>').append( $(`<p>Full Name: <span>${employee.FirstName}</span> <span>${employee.LastName}</span></p>`), $(`<p>Birth Date: <span>${employee.BirthDate}</span></p>`), $(`<p>Address: <span>${employee.Address}</span></p>`), $(`<p>Hire Date: <span>${employee.HireDate}</span></p>`), $(`<p>Position: <span>${employee.Position}</span></p>`), ); }; const popup = $('#popup').dxPopup({ contentTemplate: popupContentTemplate, width: 300, height: 280, container: '.dx-viewport', showTitle: true, title: 'Information', visible: false, dragEnabled: false, hideOnOutsideClick: true, showCloseButton: false, position: { at: 'bottom', my: 'center', collision: 'fit', }, toolbarItems: [{ locateInMenu: 'always', widget: 'dxButton', toolbar: 'top', options: { text: 'More info', onClick() { const message = `More info about ${employee.FirstName} ${employee.LastName}`; DevExpress.ui.notify({ message, position: { my: 'center top', at: 'center top', }, }, 'success', 3000); }, }, }, { widget: 'dxButton', toolbar: 'bottom', location: 'before', options: { icon: 'email', stylingMode: 'contained', text: 'Send', onClick() { const message = `Email is sent to ${employee.FirstName} ${employee.LastName}`; DevExpress.ui.notify({ message, position: { my: 'center top', at: 'center top', }, }, 'success', 3000); }, }, }, { widget: 'dxButton', toolbar: 'bottom', location: 'after', options: { text: 'Close', stylingMode: 'outlined', type: 'normal', onClick() { popup.hide(); }, }, }], }).dxPopup('instance'); employees.forEach((currentEmployee) => { $('<li>').append( $('<img>') .attr('alt', `${currentEmployee.FirstName} ${currentEmployee.LastName}`) .attr('src', currentEmployee.Picture) .attr('id', `image${currentEmployee.ID}`), $('<br>'), $('<span>').html(`<i>${currentEmployee.FirstName}</i>`), $('<span>').html(` <i>${currentEmployee.LastName}</i>`), $('<br>'), $('<div>') .addClass('button-info') .dxButton({ text: 'Details', onClick() { employee = currentEmployee; popup.option({ contentTemplate: () => popupContentTemplate(), 'position.of': `#image${employee.ID}`, }); popup.show(); }, }), ).appendTo($('#employees')); }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.2.6/css/dx.light.css" /> <script src="js/dx.all.js"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="container"> <div class="header">Employees</div> <ul id="employees"></ul> <div id="popup"></div> </div> </div> </body> </html>
.header { font-size: 34px; text-align: center; } #container { padding: 10px; } #container ul { list-style-type: none; text-align: center; } #container ul li { display: inline-block; width: 160px; margin: 10px; } #container ul li img { width: 100px; } .button-info { margin: 10px; } .dx-popup-content p { margin-bottom: 10px; margin-top: 0; }
const employees = [{ ID: 7, FirstName: 'Sandra', LastName: 'Johnson', Prefix: 'Mrs.', Position: 'Controller', Picture: '../../../../images/employees/06.png', BirthDate: '1974/11/15', HireDate: '2005/05/11', Notes: "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi.\r\n\r\nSandra has 2 daughters both of whom are accomplished gymnasts.", Address: '4600 N Virginia Rd.', }, { ID: 10, FirstName: 'Kevin', LastName: 'Carter', Prefix: 'Mr.', Position: 'Shipping Manager', Picture: '../../../../images/employees/07.png', BirthDate: '1978/01/09', HireDate: '2009/08/11', Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months.\r\n\r\nWhen not in the office, he is usually on the basketball court playing pick-up games.', Address: '424 N Main St.', }, { ID: 11, FirstName: 'Cynthia', LastName: 'Stanwick', Prefix: 'Ms.', Position: 'HR Assistant', Picture: '../../../../images/employees/08.png', BirthDate: '1985/06/05', HireDate: '2008/03/24', Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. \r\n\r\nShe was recently awarded employee of the month. Way to go Cindy!', Address: '2211 Bonita Dr.', }, { ID: 30, FirstName: 'Kent', LastName: 'Samuelson', Prefix: 'Dr.', Position: 'Ombudsman', Picture: '../../../../images/employees/02.png', BirthDate: '1972/09/11', HireDate: '2009/04/22', Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.', Address: '12100 Mora Dr', }];

DevExtreme v23.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Overview

This example demonstrates how to show and hide the Popup component, populate it with content, specify its position and other settings.

To see step-by-step instructions on how to get started with the DevExtreme Popup component, refer to the following tutorial: Getting Started with Popup.

Show and Hide the Popup

Bind the visible property to a Boolean variable (popupVisible in this demo). Next, implement the showInfo(employee) method to set this Boolean variable to true. This causes the Popup to appear. To close a Popup, choose one of the following options:

  • Built-in close button
    Enable the showCloseButton property to display the Close button in a Popup's top toolbar.

  • Custom close button
    This demo shows how to add custom buttons to a Popup. One of these buttons uses an onClick handler to set the popupVisible variable to false, causing the Popup to disappear. Refer to the next section (Configure the Popup) to learn how you can populate a popup with custom controls.

  • On outside click
    Enable the hideOnOutsideClick property to allow users to hide the Popup by clicking outside the component.

Configure the Popup

The Popup inner area is divided into three parts:

  • Top toolbar

    • Predefined
      Set showTitle to true and use the title property to specify the caption. The Close button will appear if you do not disable the showCloseButton property.

    • Custom
      Add toolbarItems markup and set each item's toolbar property to top. If you want to display an item in the overflow menu, as shown in this demo, set the item's locateInMenu property to always. You can also assign never to this property to keep the item outside the overflow menu, or you can assign auto to hide the item in the menu if the Popup's width decreases.

  • Content
    To populate the Popup with content, add markup inside the component.

  • Bottom toolbar
    To enable the bottom toolbar, declare toolbarItems in the markup as shown in this demo. Set each item's toolbar property to bottom. To learn more about toolbar configuration, refer to the following tutorial: Getting Started with Toolbar

Resize and Position

To specify Popup size, use the height and width properties.

In this demo, each Popup's location is relative to the image. The code specifies the my, at, and of properties of the position object. The configuration in the demo reads as follows: "place my center side at the bottom side of the #image${employee.ID} element."

Use the container property to select the container in which you want to render the Popup. If you set the container property to an element on the page, the shading applies to this element.

Turn on the dragEnabled option to allow users to move a Popup around the page.

Backend API
<template> <div id="container"> <div class="header">Employees</div> <ul> <EmployeeItem v-for="employee in employees" :key="employee.ID" :employee="employee" :show-info="showInfo" /> </ul> <DxPopup v-model:visible="popupVisible" :drag-enabled="false" :hide-on-outside-click="true" :show-close-button="false" :show-title="true" :width="300" :height="280" container=".dx-viewport" title="Information" > <DxPosition at="bottom" my="center" v-model:of="positionOf" collision="fit" /> <DxToolbarItem widget="dxButton" toolbar="top" locate-in-menu="always" :options="moreInfoButtonOptions" /> <DxToolbarItem widget="dxButton" toolbar="bottom" location="before" :options="emailButtonOptions" /> <DxToolbarItem widget="dxButton" toolbar="bottom" location="after" :options="closeButtonOptions" /> <p> Full Name: <span>{{ currentEmployee.FirstName }}</span> <span>{{ currentEmployee.LastName }}</span> </p> <p> Birth Date: <span>{{ currentEmployee.BirthDate }}</span> </p> <p> Address: <span>{{ currentEmployee.Address }}</span> </p> <p> Hire Date: <span>{{ currentEmployee.HireDate }}</span> </p> <p> Position: <span>{{ currentEmployee.Position }}</span> </p> </DxPopup> </div> </template> <script setup lang="ts"> import { ref } from 'vue'; import { DxPopup, DxPosition, DxToolbarItem } from 'devextreme-vue/popup'; import notify from 'devextreme/ui/notify'; import EmployeeItem from './EmployeeItem.vue'; import { employees } from './data.ts'; type Employee = typeof employees[0]; const currentEmployee = ref<Employee>({}); const popupVisible = ref(false); const positionOf = ref(''); const closeButtonOptions = { text: 'Close', stylingMode: 'outlined', type: 'normal', onClick: () => { popupVisible.value = false; }, }; const moreInfoButtonOptions = { text: 'More info', onClick: () => { const message = `More info about ${currentEmployee.value.FirstName} ${currentEmployee.value.LastName}`; notify({ message, position: { my: 'center top', at: 'center top', }, }, 'success', 3000); }, }; const emailButtonOptions = { icon: 'email', stylingMode: 'contained', text: 'Send', onClick: () => { const message = `Email is sent to ${currentEmployee.value.FirstName} ${currentEmployee.value.LastName}`; notify({ message, position: { my: 'center top', at: 'center top', }, }, 'success', 3000); }, }; function showInfo(employee) { currentEmployee.value = employee; positionOf.value = `#image${employee.ID}`; popupVisible.value = true; } </script> <style> .header { font-size: 34px; text-align: center; } #container { padding: 10px; } #container ul { list-style-type: none; text-align: center; } #container ul li { display: inline-block; width: 160px; margin: 10px; } #container ul li img { width: 100px; } .button-info { margin: 10px; } .dx-popup-content p { margin-bottom: 10px; margin-top: 0; } </style>
<template> <li> <img :alt="employee.FirstName + ' ' + employee.LastName" :src="employee.Picture" :id="'image' + employee.ID" ><br> <i>{{ employee.FirstName }} {{ employee.LastName }}</i><br> <DxButton :on-click="showEmployeeInfo" class="button-info" text="Details" /> </li> </template> <script setup lang="ts"> import { DxButton } from 'devextreme-vue/button'; import { employees } from './data.ts'; type Employee = typeof employees[0]; const props = withDefaults(defineProps<{ employee?: Employee, showInfo?: Function }>(), { employee: () => ({}), showInfo: () => {}, }); function showEmployeeInfo() { props.showInfo(props.employee); } </script>
window.exports = window.exports || {}; window.config = { transpiler: 'plugin-babel', meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, }, paths: { 'root:': '../../../../../', 'npm:': 'https://unpkg.com/', }, map: { 'vue': 'npm:vue@3.3.4/dist/vue.esm-browser.js', 'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.1/index.js', 'demo-ts-loader': 'root:utils/demo-ts-loader.js', 'svg-loader': 'root:utils/svg-loader.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@23.2.6/cjs', 'devextreme-vue': 'npm:devextreme-vue@23.2.6/cjs', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.6.4/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.5/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.54/dist/dx-gantt.js', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.4/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.12/inferno/package.json', ], babelOptions: { sourceMaps: false, stage0: true, }, }; System.config(window.config);
export const employees = [{ ID: 7, FirstName: 'Sandra', LastName: 'Johnson', Prefix: 'Mrs.', Position: 'Controller', Picture: '../../../../images/employees/06.png', BirthDate: '1974/11/15', HireDate: '2005/05/11', Notes: "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi.\r\n\r\nSandra has 2 daughters both of whom are accomplished gymnasts.", Address: '4600 N Virginia Rd.', }, { ID: 10, FirstName: 'Kevin', LastName: 'Carter', Prefix: 'Mr.', Position: 'Shipping Manager', Picture: '../../../../images/employees/07.png', BirthDate: '1978/01/09', HireDate: '2009/08/11', Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months.\r\n\r\nWhen not in the office, he is usually on the basketball court playing pick-up games.', Address: '424 N Main St.', }, { ID: 11, FirstName: 'Cynthia', LastName: 'Stanwick', Prefix: 'Ms.', Position: 'HR Assistant', Picture: '../../../../images/employees/08.png', BirthDate: '1985/06/05', HireDate: '2008/03/24', Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. \r\n\r\nShe was recently awarded employee of the month. Way to go Cindy!', Address: '2211 Bonita Dr.', }, { ID: 30, FirstName: 'Kent', LastName: 'Samuelson', Prefix: 'Dr.', Position: 'Ombudsman', Picture: '../../../../images/employees/02.png', BirthDate: '1972/09/11', HireDate: '2009/04/22', Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.', Address: '12100 Mora Dr', }];
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.2.6/css/dx.light.css" /> <script src="https://unpkg.com/typescript@4.2.4/lib/typescript.js"></script> <script type="module"> import * as vueCompilerSFC from "https://unpkg.com/@vue/compiler-sfc@3.3.4/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"> </div> </div> </body> </html>

<div id="container">
<div class="header">Employees</div>
<ul>
@for (employee of employees; track employee.ID) {
<li>
<img
[id]="'image' + employee.ID"
[alt]="employee.FirstName + ' ' + employee.LastName"
[src]="employee.Picture"
/>
<br />
<i>{{ employee.FirstName }} {{ employee.LastName }}</i
><br />
<dx-button
class="button-info"
text="Details"
(mouseenter)="detailsButtonMouseEnter(employee.ID)"
(onClick)="showInfo(employee)"
>
</dx-button>
</li>
}
</ul>
<dx-popup
[width]="300"
[height]="280"
[showTitle]="true"
title="Information"
[dragEnabled]="false"
[hideOnOutsideClick]="true"
[showCloseButton]="false"
container=".dx-viewport"
[(visible)]="popupVisible"
>
<dxi-popup-toolbar-item
widget="dxButton"
toolbar="top"
locateInMenu="always"
[options]="moreInfoButtonOptions"
>
</dxi-popup-toolbar-item>
<dxi-popup-toolbar-item
widget="dxButton"
toolbar="bottom"
location="before"
[options]="emailButtonOptions"
>
</dxi-popup-toolbar-item>
<dxi-popup-toolbar-item
widget="dxButton"
toolbar="bottom"
location="after"
[options]="closeButtonOptions"
>
</dxi-popup-toolbar-item>
<dxo-position at="bottom" my="center" [of]="positionOf" collision="fit">
</dxo-position>
<div *dxTemplate="let data of 'content'">
<p>
Full Name:
<span
>{{ currentEmployee.FirstName }} {{ currentEmployee.LastName }}</span
>
</p>
<p>
Birth Date:
<span>{{ currentEmployee.BirthDate }}</span>
</p>
<p>
Address:
<span>{{ currentEmployee.Address }}</span>
</p>
<p>
Hire Date:
<span>{{ currentEmployee.HireDate }}</span>
</p>
<p>
Position:
<span>{{ currentEmployee.Position }}</span>
</p>
</div>
</dx-popup>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxPopupModule, DxButtonModule } from 'devextreme-angular';
import notify from 'devextreme/ui/notify';
import { Employee, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxPopupModule,
DxButtonModule,
],
})
export class AppComponent {
currentEmployee: Employee = new Employee();
employees: Employee[];
popupVisible = false;
moreInfoButtonOptions: Record<string, unknown>;
emailButtonOptions: Record<string, unknown>;
closeButtonOptions: Record<string, unknown>;
positionOf: string;
constructor(service: Service) {
this.employees = service.getEmployees();
this.moreInfoButtonOptions = {
text: 'More info',
onClick: () => {
const message = `More info about ${this.currentEmployee.FirstName} ${this.currentEmployee.LastName}`;
notify({
message,
position: {
my: 'center top',
at: 'center top',
},
}, 'success', 3000);
},
};
this.emailButtonOptions = {
icon: 'email',
stylingMode: 'contained',
text: 'Send',
onClick: () => {
const message = `Email is sent to ${this.currentEmployee.FirstName} ${this.currentEmployee.LastName}`;
notify({
message,
position: {
my: 'center top',
at: 'center top',
},
}, 'success', 3000);
},
};
this.closeButtonOptions = {
text: 'Close',
stylingMode: 'outlined',
type: 'normal',
onClick: () => {
this.popupVisible = false;
},
};
}
detailsButtonMouseEnter(id: number) {
this.positionOf = `#image${id}`;
}
showInfo(employee: Employee) {
this.currentEmployee = employee;
this.popupVisible = true;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .header {
font-size: 34px;
text-align: center;
}
::ng-deep #container {
padding: 10px;
}
::ng-deep #container ul {
list-style-type: none;
text-align: center;
}
::ng-deep #container ul li {
display: inline-block;
width: 160px;
margin: 10px;
}
::ng-deep #container ul li img {
width: 100px;
}
::ng-deep .button-info {
margin: 10px;
}
::ng-deep .dx-popup-content p {
margin-bottom: 10px;
margin-top: 0;
}
import { Injectable } from '@angular/core';
export class Employee {
ID: number;
FirstName: string;
LastName: string;
Prefix: string;
Position: string;
Picture: string;
BirthDate: string;
HireDate: string;
Notes: string;
Address: string;
}
const employees: Employee[] = [{
ID: 7,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
Picture: '../../../../images/employees/06.png',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes: "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi.\r\n\r\nSandra has 2 daughters both of whom are accomplished gymnasts.",
Address: '4600 N Virginia Rd.',
}, {
ID: 10,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
Picture: '../../../../images/employees/07.png',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months.\r\n\r\nWhen not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
}, {
ID: 11,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
Picture: '../../../../images/employees/08.png',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. \r\n\r\nShe was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
}, {
ID: 30,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
Picture: '../../../../images/employees/02.png',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
}];
@Injectable()
export class Service {
getEmployees(): Employee[] {
return employees;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.25',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.67',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.25/package.json',
'npm:devexpress-gantt@4.1.67/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.0.7"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

If you have technical questions, please create a support ticket in the DevExpress Support Center.
import React, { useCallback, useMemo, useState } from 'react';
import { Popup, Position, ToolbarItem } from 'devextreme-react/popup';
import notify from 'devextreme/ui/notify';
import { EmployeeItem, EmployeeItemProps } from './EmployeeItem.tsx';
import { employees } from './data.ts';
const defaultCurrentEmployee: Partial<EmployeeItemProps['employee']> = {};
export default function App() {
const [currentEmployee, setCurrentEmployee] = useState(defaultCurrentEmployee);
const [popupVisible, setPopupVisible] = useState(false);
const [positionOf, setPositionOf] = useState('');
const showInfo = useCallback((employee: EmployeeItemProps['employee']) => {
setCurrentEmployee(employee);
setPositionOf(`#image${employee.ID}`);
setPopupVisible(true);
}, [setCurrentEmployee, setPositionOf, setPopupVisible]);
const hideInfo = useCallback(() => {
setCurrentEmployee({});
setPopupVisible(false);
}, [setCurrentEmployee, setPopupVisible]);
const sendEmail = useCallback(() => {
const message = `Email is sent to ${currentEmployee.FirstName} ${currentEmployee.LastName}`;
notify(
{
message,
position: {
my: 'center top',
at: 'center top',
},
},
'success',
3000,
);
}, [currentEmployee]);
const showMoreInfo = useCallback(() => {
const message = `More info about ${currentEmployee.FirstName} ${currentEmployee.LastName}`;
notify(
{
message,
position: {
my: 'center top',
at: 'center top',
},
},
'success',
3000,
);
}, [currentEmployee]);
const getInfoButtonOptions = useMemo(() => ({
text: 'More info',
onClick: showMoreInfo,
}), [showMoreInfo]);
const getEmailButtonOptions = useMemo(() => ({
icon: 'email',
stylingMode: 'contained',
text: 'Send',
onClick: sendEmail,
}), [sendEmail]);
const getCloseButtonOptions = useMemo(() => ({
text: 'Close',
stylingMode: 'outlined',
type: 'normal',
onClick: hideInfo,
}), [hideInfo]);
const getItems = useCallback(() => employees.map((employee) => (
<li key={employee.ID}>
<EmployeeItem employee={employee} showInfo={showInfo} />
</li>
)), [showInfo]);
return (
<div id="container">
<div className="header">Employees</div>
<ul>{getItems()}</ul>
<Popup
visible={popupVisible}
onHiding={hideInfo}
dragEnabled={false}
hideOnOutsideClick={true}
showCloseButton={false}
showTitle={true}
title="Information"
container=".dx-viewport"
width={300}
height={280}
>
<Position at="bottom" my="center" of={positionOf} collision="fit" />
<ToolbarItem
widget="dxButton"
toolbar="top"
locateInMenu="always"
options={getInfoButtonOptions}
/>
<ToolbarItem
widget="dxButton"
toolbar="bottom"
location="before"
options={getEmailButtonOptions}
/>
<ToolbarItem
widget="dxButton"
toolbar="bottom"
location="after"
options={getCloseButtonOptions}
/>
<p>
Full Name:
<span>{currentEmployee.FirstName}</span>
<span>{currentEmployee.LastName}</span>
</p>
<p>
Birth Date: <span>{currentEmployee.BirthDate}</span>
</p>
<p>
Address: <span>{currentEmployee.Address}</span>
</p>
<p>
Hire Date: <span>{currentEmployee.HireDate}</span>
</p>
<p>
Position: <span>{currentEmployee.Position}</span>
</p>
</Popup>
</div>
);
}
xxxxxxxxxx
import React, { useCallback, useMemo, useState } from 'react';
import { Popup, Position, ToolbarItem } from 'devextreme-react/popup';
import notify from 'devextreme/ui/notify';
import { EmployeeItem } from './EmployeeItem.js';
import { employees } from './data.js';
const defaultCurrentEmployee = {};
export default function App() {
const [currentEmployee, setCurrentEmployee] = useState(defaultCurrentEmployee);
const [popupVisible, setPopupVisible] = useState(false);
const [positionOf, setPositionOf] = useState('');
const showInfo = useCallback(
(employee) => {
setCurrentEmployee(employee);
setPositionOf(`#image${employee.ID}`);
setPopupVisible(true);
},
[setCurrentEmployee, setPositionOf, setPopupVisible],
);
const hideInfo = useCallback(() => {
setCurrentEmployee({});
setPopupVisible(false);
}, [setCurrentEmployee, setPopupVisible]);
const sendEmail = useCallback(() => {
const message = `Email is sent to ${currentEmployee.FirstName} ${currentEmployee.LastName}`;
notify(
{
message,
position: {
my: 'center top',
at: 'center top',
},
},
'success',
3000,
);
}, [currentEmployee]);
const showMoreInfo = useCallback(() => {
const message = `More info about ${currentEmployee.FirstName} ${currentEmployee.LastName}`;
notify(
{
message,
position: {
my: 'center top',
at: 'center top',
},
},
'success',
3000,
);
}, [currentEmployee]);
const getInfoButtonOptions = useMemo(
() => ({
text: 'More info',
onClick: showMoreInfo,
}),
[showMoreInfo],
);
const getEmailButtonOptions = useMemo(
() => ({
icon: 'email',
stylingMode: 'contained',
text: 'Send',
onClick: sendEmail,
}),
[sendEmail],
);
const getCloseButtonOptions = useMemo(
() => ({
text: 'Close',
stylingMode: 'outlined',
type: 'normal',
onClick: hideInfo,
}),
[hideInfo],
);
const getItems = useCallback(
() =>
employees.map((employee) => (
<li key={employee.ID}>
<EmployeeItem
employee={employee}
showInfo={showInfo}
/>
</li>
)),
[showInfo],
);
return (
<div id="container">
<div className="header">Employees</div>
<ul>{getItems()}</ul>
<Popup
visible={popupVisible}
onHiding={hideInfo}
dragEnabled={false}
hideOnOutsideClick={true}
showCloseButton={false}
showTitle={true}
title="Information"
container=".dx-viewport"
width={300}
height={280}
>
<Position
at="bottom"
my="center"
of={positionOf}
collision="fit"
/>
<ToolbarItem
widget="dxButton"
toolbar="top"
locateInMenu="always"
options={getInfoButtonOptions}
/>
<ToolbarItem
widget="dxButton"
toolbar="bottom"
location="before"
options={getEmailButtonOptions}
/>
<ToolbarItem
widget="dxButton"
toolbar="bottom"
location="after"
options={getCloseButtonOptions}
/>
<p>
Full Name:
<span>{currentEmployee.FirstName}</span>
<span>{currentEmployee.LastName}</span>
</p>
<p>
Birth Date: <span>{currentEmployee.BirthDate}</span>
</p>
<p>
Address: <span>{currentEmployee.Address}</span>
</p>
<p>
Hire Date: <span>{currentEmployee.HireDate}</span>
</p>
<p>
Position: <span>{currentEmployee.Position}</span>
</p>
</Popup>
</div>
);
}
xxxxxxxxxx
import React, { useCallback } from 'react';
import { Button } from 'devextreme-react/button';
export interface EmployeeItemProps {
employee: { ID: number; FirstName: string; LastName: string; Prefix: string; Position: string; Picture: string; BirthDate: string; HireDate: string; Notes: string; Address: string; };
showInfo: any;
}
export function EmployeeItem(props: EmployeeItemProps) {
const showInfo = useCallback(() => {
props.showInfo(props.employee);
}, [props]);
return (
<React.Fragment>
<img alt={`${props.employee.FirstName} ${props.employee.LastName}`} src={ props.employee.Picture } id={ `image${props.employee.ID}` } /><br />
<i>{props.employee.FirstName} {props.employee.LastName}</i><br />
<Button
className="button-info"
text="Details"
onClick={showInfo}
/>
</React.Fragment>
);
}
xxxxxxxxxx
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
xxxxxxxxxx
export const employees = [{
ID: 7,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
Picture: 'images/employees/06.png',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes: "Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi.\r\n\r\nSandra has 2 daughters both of whom are accomplished gymnasts.",
Address: '4600 N Virginia Rd.',
}, {
ID: 10,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
Picture: 'images/employees/07.png',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes: 'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months.\r\n\r\nWhen not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
}, {
ID: 11,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
Picture: 'images/employees/08.png',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes: 'Cindy joined us in 2008 and has been in the HR department for 2 years. \r\n\r\nShe was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
}, {
ID: 30,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
Picture: 'images/employees/02.png',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes: 'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
}];
xxxxxxxxxx
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
'bundles:': 'bundles/',
'externals:': 'bundles/externals/',
},
defaultExtension: 'js',
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@24.2.5/cjs',
'devextreme-react': 'npm:devextreme-react@24.2.5/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.15/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.59/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);
xxxxxxxxxx
import React, { useCallback } from 'react';
import { Button } from 'devextreme-react/button';
export function EmployeeItem(props) {
const showInfo = useCallback(() => {
props.showInfo(props.employee);
}, [props]);
return (
<React.Fragment>
<img
alt={`${props.employee.FirstName} ${props.employee.LastName}`}
src={props.employee.Picture}
id={`image${props.employee.ID}`}
/>
<br />
<i>
{props.employee.FirstName} {props.employee.LastName}
</i>
<br />
<Button
className="button-info"
text="Details"
onClick={showInfo}
/>
</React.Fragment>
);
}
xxxxxxxxxx
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
xxxxxxxxxx
export const employees = [
{
ID: 7,
FirstName: 'Sandra',
LastName: 'Johnson',
Prefix: 'Mrs.',
Position: 'Controller',
Picture: 'images/employees/06.png',
BirthDate: '1974/11/15',
HireDate: '2005/05/11',
Notes:
"Sandra is a CPA and has been our controller since 2008. She loves to interact with staff so if you've not met her, be certain to say hi.\r\n\r\nSandra has 2 daughters both of whom are accomplished gymnasts.",
Address: '4600 N Virginia Rd.',
},
{
ID: 10,
FirstName: 'Kevin',
LastName: 'Carter',
Prefix: 'Mr.',
Position: 'Shipping Manager',
Picture: 'images/employees/07.png',
BirthDate: '1978/01/09',
HireDate: '2009/08/11',
Notes:
'Kevin is our hard-working shipping manager and has been helping that department work like clockwork for 18 months.\r\n\r\nWhen not in the office, he is usually on the basketball court playing pick-up games.',
Address: '424 N Main St.',
},
{
ID: 11,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Prefix: 'Ms.',
Position: 'HR Assistant',
Picture: 'images/employees/08.png',
BirthDate: '1985/06/05',
HireDate: '2008/03/24',
Notes:
'Cindy joined us in 2008 and has been in the HR department for 2 years. \r\n\r\nShe was recently awarded employee of the month. Way to go Cindy!',
Address: '2211 Bonita Dr.',
},
{
ID: 30,
FirstName: 'Kent',
LastName: 'Samuelson',
Prefix: 'Dr.',
Position: 'Ombudsman',
Picture: 'images/employees/02.png',
BirthDate: '1972/09/11',
HireDate: '2009/04/22',
Notes:
'As our ombudsman, Kent is on the front-lines solving customer problems and helping our partners address issues out in the field. He is a classically trained musician and is a member of the Chamber Orchestra.',
Address: '12100 Mora Dr',
},
];
xxxxxxxxxx
<html lang="en">
<head></head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
xxxxxxxxxx
.header {
font-size: 34px;
text-align: center;
}
#container {
padding: 10px;
}
#container ul {
list-style-type: none;
text-align: center;
}
#container ul li {
display: inline-block;
width: 160px;
margin: 10px;
}
#container ul li img {
width: 100px;
}
.button-info {
margin: 10px;
}
.dx-popup-content p {
margin-bottom: 10px;
margin-top: 0;
}
Show and Hide the Popup
Bind the visible property to a Boolean variable (popupVisible
in this demo). Next, implement the showInfo(employee)
method to set this Boolean variable to true
. This causes the Popup to appear. To close a Popup, choose one of the following options:
-
Built-in close button
Enable the showCloseButton property to display the Close button in a Popup's top toolbar. -
Custom close button
This demo shows how to add custom buttons to a Popup. One of these buttons uses an onClick handler to set thepopupVisible
variable tofalse
, causing the Popup to disappear. Refer to the next section (Configure the Popup) to learn how you can populate a popup with custom controls. -
On outside click
Enable the hideOnOutsideClick property to allow users to hide the Popup by clicking outside the component.
Configure the Popup
The Popup inner area is divided into three parts:
-
Top toolbar
-
Predefined
Set showTitle totrue
and use the title property to specify the caption. The Close button will appear if you do not disable the showCloseButton property. -
Custom
Add toolbarItems markup and set each item's toolbar property totop
. If you want to display an item in the overflow menu, as shown in this demo, set the item's locateInMenu property toalways
. You can also assignnever
to this property to keep the item outside the overflow menu, or you can assignauto
to hide the item in the menu if the Popup's width decreases.
-
-
Content
To populate the Popup with content, add markup inside the component. -
Bottom toolbar
To enable the bottom toolbar, declare toolbarItems in the markup as shown in this demo. Set each item's toolbar property tobottom
. To learn more about toolbar configuration, refer to the following tutorial: Getting Started with Toolbar
Resize and Position
To specify Popup size, use the height and width properties.
In this demo, each Popup's location is relative to the image. The code specifies the my, at, and of properties of the position object. The configuration in the demo reads as follows: "place my center
side at the bottom
side of the #image${employee.ID}
element."
Use the container property to select the container in which you want to render the Popup. If you set the container property to an element on the page, the shading applies to this element.
Turn on the dragEnabled option to allow users to move a Popup around the page.